///////////////////////////////////////////////////////////////////////////////
// histogram.h
// ===========
// generate histogram and equalize the histogram to enhance image contrast
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2006-09-25
// UPDATED: 2006-09-25
///////////////////////////////////////////////////////////////////////////////

#ifndef DIP_HISTOGRAM_H
#define DIP_HISTOGRAM_H

namespace dip
{

///////////////////////////////////////////////////////////////////////////////
// generate histogram of input image
///////////////////////////////////////////////////////////////////////////////
bool getHistogram(const unsigned char *image, int width, int height, unsigned int *histo, int histoSize);

///////////////////////////////////////////////////////////////////////////////
// generate cumulative histogram of input image
///////////////////////////////////////////////////////////////////////////////
bool getSumHistogram(const unsigned char *image, int width, int height, unsigned int *sumHisto, int histoSize);

///////////////////////////////////////////////////////////////////////////////
// enhance image contrast by equalizing histogram
///////////////////////////////////////////////////////////////////////////////
bool equalizeHistogram(const unsigned char *in, int width, int height, unsigned char *out);

}
#endif
